#include <assert.h>
#include <string.h>
#include <stdio.h>
#include "util.h"
#include "object.h"
#include "classmember.h"
#include "class.h"

/* static */ unsigned int
Cclassmember::hash(const char *nameP)
{
	int		ret  = 0;
	int		c;
	const	char *P;

	for (P = nameP; (c = *P) ; ++P) {
		ret  += c;
		ret <<= 1;
		if (ret & HASHSIZE) {
			ret |= 1;
	}	}
	return(ret & (HASHSIZE-1));
}

void
Cclassmember::addto_class(void)
{
	char	*nameP;
	Cclass	*classP;
	int		c, lth;

	nameP  = m_nameP;

	if (*nameP != '_' || nameP[1] != 'Z') {
		return;
	}
	// name mangled
	if (nameP[2] != 'N') {
		// Not a nested name
		return;
	}
	for (nameP += 3; ; ++nameP) {
		c = *nameP;
		if (!c) {
			return;
		}
		if (c >= '0' && c <= '9') {
			break;
	}	}
	lth = c - '0';
	for (;;) {
		c   = *(++nameP);
		if (c < '0' || c > '9') {
			break;
		}
		lth = lth*10 + c - '0';
	}
	c = nameP[lth];
	nameP[lth] = 0;
	classP = Cclass::locate(nameP);
	nameP[lth] = c;
}

Cclassmember::Cclassmember(const char *nameP)
{
	name(nameP);
	m_fileP   = 0;
	m_lineno  = 0;
	m_parentP = 0;
	m_flags   = 0;
	addto_class();
}

void
Cclassmember::emit_class(void) const
{
	char	*nameP;
	Cclass	*classP;
	int		c, lth;

	nameP  = m_nameP;

	if (*nameP != '_' || nameP[1] != 'Z') {
		return;
	}
	// name mangled
	if (nameP[2] != 'N') {
		// Not a nested name
		return;
	}
	for (nameP += 3; ; ++nameP) {
		c = *nameP;
		if (!c) {
			return;
		}
		if (c >= '0' && c <= '9') {
			break;
	}	}
	lth = c - '0';
	for (;;) {
		c   = *(++nameP);
		if (c < '0' || c > '9') {
			break;
		}
		lth = lth*10 + c - '0';
	}
	c = nameP[lth];
	nameP[lth] = 0;
	classP = Cclass::find(nameP);
	assert(classP);
	nameP[lth] = c;

	fputs("M ", stdout);
	classP->emit_id();
	fputc(' ', stdout);
	emit_id();
	fputc('\n', stdout);
}

